--RESOURCES/SETTINGS
love.graphics.setBackgroundColor (0,0.4,0)
love.graphics.setDefaultFilter ('nearest','nearest')

--repeating background
local W,H = love.graphics.getDimensions()

local bgImage = love.graphics.newImage ('images/grass.png')
local bgQuad = love.graphics.newQuad (0,0,W,H,bgImage:getWidth(),bgImage:getHeight())
bgImage:setWrap('repeat','repeat')
--

local sphere = love.graphics.newImage ('images/sphere.png')
local sphereMask = love.graphics.newImage ('images/sphereMask.png')
local sphereShadow = love.graphics.newImage ('images/sphereShadow.png')

local shadowCanvas = love.graphics.newCanvas() --canvas for shadows beneath sphere
local shadowCanvas2 = love.graphics.newCanvas() --canvas for shadows on sphere
local shadowTrans = 0.4 --transparency of shadows

local mx, my = love.mouse.getPosition()
--

--LOAD
function love.load ()
end
--

--MASK SHADER
local mask_shader = love.graphics.newShader[[
   vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords) {
      if (Texel(texture, texture_coords).rgb == vec3(0.0)) {
         // a discarded pixel wont be applied as the stencil.
         discard;
      }
      return vec4(1.0);
   }
]]
--

--SET STENCIL
local function myStencilFunction()
    
 love.graphics.setShader(mask_shader)
  love.graphics.draw(sphereMask,100,100)
 love.graphics.setShader()
 
end
--

--DRAW STENCIL
local function drawStencil()
 love.graphics.stencil(myStencilFunction, "replace", 1) --1
 love.graphics.setStencilTest("greater", 0) --0
 
 love.graphics.setColor(1,1,1,shadowTrans) --transparency/color of shadows
  love.graphics.draw(shadowCanvas2) --this canvas is only drawn on the sphere mask.
 love.graphics.setColor(1,1,1,1) --reset to white
  
 love.graphics.setStencilTest()
end
--

--UPDATE CANVAS
local function updateCanvas(canvas)
love.graphics.setCanvas{canvas,stencil=true}
 love.graphics.clear(0,0,0,0) --clear (black)
 --love.graphics.setBlendMode("alpha", "premultiplied")
 
 --[[
    anything drawn to the second canvas will be drawn onto the sphere mask, which is
    drawn over the top of the sphere.
   ]]
  love.graphics.draw (sphereShadow,mx-16,my-16)--draw shadow at mouse x,y (with offset)
  
 --anything drawn onto the first canvas will be drawn beneath the sphere. 
 if canvas == shadowCanvas then 
  love.graphics.draw (sphereShadow,100,116)
 end
 
 --love.graphics.setBlendMode("alpha")
 love.graphics.setCanvas()   
end
--

--UPDATE
function love.update ()

 mx, my = love.mouse.getPosition()
 
 updateCanvas(shadowCanvas)
 updateCanvas(shadowCanvas2)
 
end
--

--DRAW
function love.draw()
    
 love.graphics.draw(bgImage,bgQuad,0,0) --draw repeating background

 love.graphics.setColor (1,1,1,shadowTrans)
  love.graphics.draw (shadowCanvas) --draw shadows beneath sphere (first canvas)
 love.graphics.setColor (1,1,1,1)
 
  love.graphics.draw (sphere,100,100)
 drawStencil() --draw shadows on top of sphere (using a mask and a second canvas)
 
end
--